#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"
#define ja stav.hraci[0]
#define For(Q,W) for(int Q=0;Q<W;Q++)

#define utok 0
#define obrana 1
#define zber 2


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;
int naKoho;
int kolo;
int akoBudemUtocit;
double zdroje_attack, zdroje_def, zdroje_gather;
/*new*/vector<pair<int,int> > kamStavatVeze, kamStavatTazbu;
queue<pair<int,int> > haldicka;
/*mapa na hodnoty ciest*/ vector<vector<double> > hodnota_cesty;
			  vector<vector<int> > vzdialenost_bodu;
int dx[4] = {-1,0,1,0};
int dy[4] = {0,1,0,-1};
  
int dx2[8] ={-1,0,1,-1,1,-1,0,1};
int dy2[8] ={-1,-1,-1,0,0,1,1,1};

int flag;
double banka_attack=0,banka_def=0, banka_gather=0;
int prirastok, stare=0;
int najblizsiSpawn=100;
int ako_utocim;
int frekvencnaKonstanta=50;
bool boolean = 1;

void sup(double a,double b, double c){
    zdroje_attack=a;
    zdroje_def=b;
    zdroje_gather=c;
}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}

bool special(){
  int ok_hrac=0;
  For(i,mapa.pocetHracov) if(stav.hraci[i].umrel==0) ok_hrac++;
  int kolko_obrany=0;
  For(i,VEZA_POCET_BOJOVYCH) kolko_obrany+=pocetVezi(i);
  
  if((najblizsiSpawn<14)&&(kolo<60)){
    frekvencnaKonstanta = 1;
    if(kolo<2) sup(0.5,0.0,0.5);
    else sup(1.0,0.0,0.0);
    return true;
  }
  else if(ok_hrac<2){
      sup(0.0,0.8,0.2);
    return true;
  }
  else if(ja.utocnici.size()>40  ||(ja.utocnici.size() &&kolko_obrany<3)){
    sup(0.0,1.0,0.0);
    return true;
  }
    
  else return false;
  
}

void divide(){
  if(!special()){
  if(kolo<10)		sup(0.0,0.0,1.0);
  else if(kolo<300)	sup(0.0,0.9,0.1);
  else if(kolo<400)	sup(0.0,0.6,0.4);
  else if(kolo<700)	{sup(0.3,0.6,0.1);frekvencnaKonstanta = 50;}
  else 			sup(0.8,0.1,0.1);
  }
}

// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  int mam = ja.drevo;
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  fprintf(stderr, "mal som %d, vyslo %d, teraz mam %d\n", mam, (int)uspech, ja.drevo);
  if (uspech){ prikazy.push_back(p);   // potom to posleme serveru
    if(flag==utok) banka_attack += ja.drevo-mam;
    if(flag==obrana) banka_def += ja.drevo-mam;
    if(flag==zber) banka_gather += ja.drevo-mam;
  }
  fprintf(stderr, "teraz mam %f\n", banka_gather);
  
  return uspech;
}


void trtko(int desom_x, int desom_y,double pocetnost){
  hodnota_cesty[desom_y][desom_x]+=pocetnost;
 
  double posible=0;
  
  For(i,4){
      if((mapa.zisti(desom_x+dx[i],desom_y+dy[i])>1)&&(vzdialenost_bodu[desom_y+dy[i]][desom_x+dx[i]]<vzdialenost_bodu[desom_y][desom_x])) posible++;  
  }
  
  For(i,4){
      if(mapa.zisti(desom_x+dx[i],desom_y+dy[i])>1&&vzdialenost_bodu [desom_y+dy[i]] [desom_x+dx[i]]<vzdialenost_bodu[desom_y][desom_x]){
	trtko(desom_x+dx[i],desom_y+dy[i],pocetnost/posible);  
      }
  }
  
  
  
}

void initHodnotaCesty(){
  int domcek_x,domcek_y;
    For(i,mapa.h) For(j,mapa.w) if(mapa.pole[i][j]==MAPA_CIEL) { domcek_x=j ;domcek_y=i;}  // najdeme domcek
    
    //For(i,mapa.h) For(j,mapa.w){ vzdialenost_bodu[i][j]=999999999; hodnota_cesty[i][j]=0}// najdeme domcek
    hodnota_cesty.resize(mapa.h,vector<double>(mapa.w,0));
    vzdialenost_bodu.resize(mapa.h,vector<int>(mapa.w,999999999));
    
    
    haldicka.push(make_pair(domcek_x,domcek_y));
    vzdialenost_bodu[domcek_y][domcek_x]=1;
    
    while(!haldicka.empty()){
	 pair<int,int> desom=haldicka.front();
	 haldicka.pop();
	 
	 For(i,4){
	    int nove_x=desom.first+dx[i],nove_y=desom.second+dy[i];
	    
	    if((mapa.zisti(nove_x,nove_y)>1)&&(vzdialenost_bodu[nove_y][nove_x]>vzdialenost_bodu[desom.second][desom.first]+1)){
		vzdialenost_bodu[nove_y][nove_x]=vzdialenost_bodu[desom.second][desom.first]+1;
		
		haldicka.push(make_pair(nove_x,nove_y));
	    }
	   
	}
	 
    }
    
    For(i,mapa.h) For(j,mapa.w) if(mapa.pole[i][j]==MAPA_SPAWN){ trtko(j,i,1);
      hodnota_cesty[i][j] = 0;
      najblizsiSpawn = min(najblizsiSpawn,vzdialenost_bodu[i][j]);
    }
    hodnota_cesty[domcek_y][domcek_x] = 0;
    
}

void initKamStavat(){	//Mario
    vector<vector<double> >hodnota_pozemku(mapa.h,vector<double>(mapa.w,0));
    For(i,mapa.h) For(j,mapa.w) if(mapa.zisti(j,i)>1){
      For(k,4)if(mapa.zisti(j+dx[k],i+dy[k])==MAPA_POZEMOK) 
	hodnota_pozemku[i+dy[k]][j+dx[k]] += hodnota_cesty[i][j]+0.001*(200-min(200,vzdialenost_bodu[i][j])); 
    }
    vector<pair<double,pair<int,int> > > zor;
    For(i,mapa.h) For(j,mapa.w) 
      if(mapa.zisti(j,i)==MAPA_POZEMOK)
	zor.push_back(make_pair(hodnota_pozemku[i][j],make_pair(j,i)));
    sort(zor.begin(), zor.end());
    For(i,zor.size()){
      kamStavatTazbu.push_back(zor[zor.size()-i-1].second);
      kamStavatVeze.push_back(zor[i].second);
    }
    For(i,mapa.h){ For(j,mapa.w){
      cerr << hodnota_pozemku[i][j] << " ";
    }
      cerr << endl;
    }
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
  ako_utocim= UTOCNIK_MUCHA;
  initHodnotaCesty();
  initKamStavat();
  For(i,mapa.h){ For(j,mapa.w){
      cerr << vzdialenost_bodu[i][j] << " ";
    }
      cerr << endl;
    }
    For(i,mapa.h){ For(j,mapa.w){
      cerr << hodnota_cesty[i][j] << " ";
    }
      cerr << endl;
    }
}


int zistiCenuVeze(int kolko, int typ) {
  int pocet = kolko;
  FOREACH(it, ja.veze) if (it->typ == typ) pocet++;
  return kVezaCena0[typ] + pocet * kVezaCena1[typ] + pocet * pocet * kVezaCena2[typ];
}

void attack(){
  //int posible=ja.drevo*zdroje_attack;
  if ((kolo > 100)&&(boolean)){ako_utocim = rand()%UTOCNIK_POCET_TYPOV;boolean = 0;}
  for(int i=1; i<mapa.pocetHracov;i++)
  if(stav.hraci[i].umrel)continue;
  else {
      naKoho=i;
    break;
  }
    
  while (pocetVezi(VEZA_LAB_PRVY+ako_utocim) < 1&& zistiCenuVeze(0,VEZA_LAB_PRVY+ako_utocim)<banka_attack) {
    pair<int,int> kamStavat;
    if(kamStavatTazbu.size() > 0){
      kamStavat = kamStavatTazbu.back(); 
      }
    else
      kamStavat = make_pair(0,0);
    if (!vykonaj(Prikaz::buduj(kamStavat.first, kamStavat.second, VEZA_LAB_PRVY+ako_utocim))) break;
    else kamStavatTazbu.pop_back();
  }
  if(kolo%frekvencnaKonstanta==0){
  while (banka_attack>kUtokCena[ako_utocim]) {
    if (!vykonaj(Prikaz::utoc(ako_utocim, naKoho))) break;
    
  }
  }
}

void def(){
  int stavane=0;
  int counter=0;
  int aky_def=rand()%VEZA_POCET_BOJOVYCH;
  if(kolo < 60) aky_def = VEZA_PLACACKA;
  
  while (banka_def>zistiCenuVeze(stavane,aky_def)) {
    pair<int,int> kamStavat;
    if(kamStavatVeze.size() > 0){
      kamStavat = kamStavatVeze.back(); 
      }
    else
      kamStavat = make_pair(0,0);
    if(vykonaj(Prikaz::buduj(kamStavat.first,kamStavat.second, aky_def))){
    stavane++;
    kamStavatVeze.pop_back();
      
    }
    counter++;
    if(counter>30) break;
  } 
}

void gather(){
  int stavane=0;
  int counter=0;
  while (pocetVezi(VEZA_ZBERAC) < (mapa.w*mapa.h)/10 && banka_gather>zistiCenuVeze(stavane,VEZA_ZBERAC)) {
    pair<int,int> kamStavat;
    if(kamStavatTazbu.size()>0){
      kamStavat = kamStavatTazbu.back(); 
      }
    else kamStavat = make_pair(0,0);
    if(vykonaj(Prikaz::buduj(kamStavat.first, kamStavat.second, VEZA_ZBERAC))) kamStavatTazbu.pop_back();
    counter++;
    stavane++;
    if(counter>10) break;
  }
    
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  prirastok = ja.drevo-stare;
  zdroje_attack=0, zdroje_def=0, zdroje_gather=0;
  kolo++;
  divide();
  banka_attack += prirastok*zdroje_attack;
  banka_def += prirastok*zdroje_def;
  banka_gather += prirastok*zdroje_gather;
  if(1){
  flag = utok;
  attack();
  flag = obrana;
  def();
  flag =  zber;
  gather();
  }
  cerr << banka_attack << " " << banka_def << " " << banka_gather << endl;
  /*
  int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  while (pocetVezi(VEZA_ZBERAC) < 3) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_ZBERAC))) break;
  }
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
  while (true) {
    int naKoho = 1 + rand() % (mapa.pocetHracov-1);
    if (!vykonaj(Prikaz::utoc(akoBudemUtocit, naKoho))) break;
  }
  // hmm este nejaku obranu by to chcelo...
  */
  stare = ja.drevo;
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();
  kolo=0;
  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cerr << kamStavatTazbu.size() << endl;
    cerr << kamStavatVeze.size() << endl;
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

