#include <cstdio>
#include <cstdlib>

#include <iostream>
#include <vector>
using namespace std;
#include <ctime>
#include "common.h"
#include "marshal.h"
#include "update.h"


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
  srand(time(NULL));
  
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
   
  // nacitame mapu - odstranime nepouzivane cesty,

  int x,y,t=0,i;
  for(i=0;i<3;i++)
  {
    do
    {
      x=rand()%mapa.w;
      y=rand()%mapa.h;
      t++;
    } while (!vykonaj(Prikaz::buduj(x, y, rand()%10))&&(t<10000));
  }
  
  //najdeme loziska dreva (energie) (sortneme),
  
  // preratame vetvenie ciest (kolko percent vojkov tade ide) do grafu
  
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

