#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


struct str
{
int x;
int y;
bool used;
};


bool isNear(int,int);


Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;

vector<str> Pozemky_veze,Pozemky_ostatne;
int akoBudemUtocit;

int zberac=0,vezaSipy=0,labMucha=0;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;

for(int i=0; i<mapa.w; i++)
for(int j=0; j<=mapa.h; j++){

  cerr<<isNear(i,j)<<endl;
  if(isNear(i,j)==true && mapa.zisti(i,j)==MAPA_POZEMOK){
str temp;
temp.x=i;
temp.y=j;

Pozemky_veze.push_back(temp);
//cerr<<i<<" "<<j<<" Pozemky\n";
}
else
{
if(mapa.zisti(i,j)==MAPA_POZEMOK)
{
str temp;
temp.x=i;
temp.y=j;
Pozemky_ostatne.push_back(temp);
//cerr<<i<<" "<<j<<" ostatne\n";
}

}
}

}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}

bool isNear(int x,int y){
return !(mapa.zisti(x+1,y)!=MAPA_CESTA&&mapa.zisti(x-1,y)!=MAPA_CESTA&& 
mapa.zisti(x,y+1)!=MAPA_CESTA&&mapa.zisti(x,y-1)!=MAPA_CESTA);

};

bool isNearMotivator(int x,int y){
  
  return !(mapa.zisti(x+1,y)==VEZA_MOTIVATOR||mapa.zisti(x-1,y)==VEZA_MOTIVATOR||
mapa.zisti(x,y+1)==VEZA_MOTIVATOR||mapa.zisti(x,y-1)==VEZA_MOTIVATOR);
  
  
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat

void zistiTah() {
  int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  //vzberiem rand policko ostatne a tam postavim zberac
if(zberac<6){
vector<str>::iterator it;
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();
 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_ZBERAC))){
zberac++;
Pozemky_ostatne.erase(it);
}


}


if(labMucha<2){
vector<str>::iterator it;
if(Pozemky_ostatne.size()>0){
it=Pozemky_ostatne.begin();
it+=rand()%Pozemky_ostatne.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MUCHA))){
labMucha++;;
Pozemky_ostatne.erase(it);
}

}

else if(Pozemky_veze.size()>0){
it=Pozemky_veze.begin();
it+=rand()%Pozemky_veze.size();

 if(vykonaj(Prikaz::buduj(it->x, it->y, VEZA_LAB_MUCHA))){
labMucha++;;
Pozemky_veze.erase(it);
}

}

}

if(vezaSipy<6){
vykonaj(Prikaz::buduj(rand()% mapa.w, rand()%mapa.h, VEZA_SIPY));
vezaSipy++;
}

if(true)
  while(vykonaj(Prikaz::buduj(rand()% mapa.w, 
rand()%mapa.h,rand()%6)) );



  /*
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
*/

  while (true) {
    int naKoho = 1 + rand() % (mapa.pocetHracov-1);
    if (!vykonaj(Prikaz::utoc(1, 3))) break;
  }

  // hmm este nejaku obranu by to chcelo...
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

