#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"
#define ja stav.hraci[0]

Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;
int naKoho;
int kolo;
int akoBudemUtocit;
double zdroje_attack, zdroje_def, zdroje_gather;

void sup(double a,double b, double c){
    zdroje_attack=a;
    zdroje_def=b;
    zdroje_gather=c;
}

void divide(){
  if(kolo<100)		sup(0.0,0.0,1.0);
  else if(kolo<300)	sup(0.2,0.7,0.1);
  else if(kolo<400)	sup(0.1,0.8,0.1);
  else if(kolo<800)	sup(0.3,0.7,0.0);
  else 			sup(1.0,0.0,0.0);
  
}

// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeby malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  srand(time(NULL) * getpid());
  akoBudemUtocit = rand() % UTOCNIK_POCET_TYPOV;
}


int pocetVezi(int typ) {
  int result = 0;
  FOREACH(it, stav.hraci[0].veze) if (it->typ == typ) result++;
  return result;
}

int zistiCenuVeze(int kolko, int typ) {
  int pocet = kolko;
  FOREACH(it, ja.veze) if (it->typ == typ) pocet++;
  return kVezaCena0[typ] + pocet * kVezaCena1[typ] + pocet * pocet * kVezaCena2[typ];
}

void attack(){
  int ako_utocim= rand()%UTOCNIK_POCET_TYPOV;
  int posible=ja.drevo*zdroje_attack;
  for(int i=1; i<mapa.pocetHracov;i++)
  if(stav.hraci[i].umrel)continue;
  else {
      naKoho=i;
    break;
  }
    
  while (pocetVezi(VEZA_LAB_PRVY+ako_utocim) < 1&& zistiCenuVeze(0,VEZA_LAB_PRVY+ako_utocim)<ja.drevo*zdroje_attack) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_LAB_PRVY+ako_utocim))) break;
  }
  if(kolo%200){
  while (posible) {
    if (!vykonaj(Prikaz::utoc(ako_utocim, naKoho))) break;
    posible-=kVezaCena0[ako_utocim];
  }
  }
}

void def(){
  int stavane=0;
  int counter=0;
  int aky_def=rand()%VEZA_POCET_BOJOVYCH;
  
  while (ja.drevo*zdroje_gather>zistiCenuVeze(stavane,aky_def)) {
    if(vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, aky_def)))
    stavane++;
    
    counter++;
    if(counter>30) break;
  } 
}


void gather(){
  int stavane=0;
  int counter=0;
  while (pocetVezi(VEZA_ZBERAC) < (mapa.w*mapa.h)/10 && ja.drevo*zdroje_gather>zistiCenuVeze(stavane,VEZA_ZBERAC)) {
    vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_ZBERAC));
    counter++;
    stavane++;
    if(counter>10) break;
  }
    
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  zdroje_attack=0, zdroje_def=0, zdroje_gather=0;
  kolo++;
  divide();
  
  attack();
  def();
  gather();
  
  /*
  int mojLab = VEZA_LAB_PRVY + akoBudemUtocit;
  while (pocetVezi(VEZA_ZBERAC) < 3) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, VEZA_ZBERAC))) break;
  }
  while (pocetVezi(mojLab) < 1) {
    if (!vykonaj(Prikaz::buduj(rand() % mapa.w, rand() % mapa.h, mojLab))) break;
  }
  while (true) {
    int naKoho = 1 + rand() % (mapa.pocetHracov-1);
    if (!vykonaj(Prikaz::utoc(akoBudemUtocit, naKoho))) break;
  }
  // hmm este nejaku obranu by to chcelo...
  */
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();
  kolo=0;
  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

