#include <cstdio>
#include <cstdlib>

#include <iostream>
#include <vector>
using namespace std;
#include <ctime>
#include "common.h"
#include "marshal.h"
#include "update.h"

int xv,yv;
Mapa mapa;
Stav stav;   // vzdy som hrac cislo 0
vector<Prikaz> prikazy;


// pomocna funkcia. volajte zo zistiTah(), napr.:
// if (!vykonaj(Prikaz::stavaj(10, 10, VEZA_LASER))) { /* zeyv malo dreva? */ }
bool vykonaj(const Prikaz& p) {
  bool uspech = vykonajPrikaz(mapa, stav, 0, p);
  if (uspech) prikazy.push_back(p);   // potom to posleme serveru
  return uspech;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
  srand(time(NULL));
  for(xv=0;xv<mapa.w;xv++)
  {
    for(yv=0;yv<mapa.h;yv++)
    {
      if(((mapa.zisti(xv+1,yv)<2)&&(mapa.zisti(xv-1,yv)<2)&&(mapa.zisti(xv,yv+1)<2)&&(mapa.zisti(xv,yv-1)<2)))
	break;
    }
    if(((mapa.zisti(xv+1,yv)<2)&&(mapa.zisti(xv-1,yv)<2)&&(mapa.zisti(xv,yv+1)<2)&&(mapa.zisti(xv,yv-1)<2)))
	break;
  }
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
     
  // nacitame mapu - odstranime nepouzivane cesty,
  int i;
  for(i=0;i<3;i++)
  {
    int x,y,t=0,co;
    do
    {
      x=rand()%mapa.w;
      y=rand()%mapa.h;
      co=rand()%7;
      t++;
      if(((mapa.zisti(x+1,y)<2)&&(mapa.zisti(x-1,y)<2)&&(mapa.zisti(x,y+1)<2)&&(mapa.zisti(x,y-1)<2)))
	co=7;
      if(xv==x&&yv==y)
	co=14;
    } while ((!vykonaj(Prikaz::buduj(x, y, co)))&&(t<1000));
  }
  int kolko=0,maxhrac;
  for(i=1;i<mapa.pocetHracov;i++)
  {
    if(stav.hraci[i].body>kolko)
    {
      kolko=stav.hraci[i].body;
      maxhrac=i;
    }
   }
  vykonaj(Prikaz::utoc(maxhrac, 4));
  
  //najdeme loziska dreva (energie) (sortneme),
  
  // preratame vetvenie ciest (kolko percent vojkov tade ide) do grafu
  
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  nacitaj(cin, mapa);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    prikazy.clear();
    zistiTah();
    uloz(cout, prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

